

let rec do_rename f1 f2 n =
  let f = f2 ^ string_of_int n ^ ".fp" in
  if Sys.file_exists f then do_rename f1 f2 (n+1)
  else 
    Sys.rename f1 f 

let tr s =
  let inpar = ref false in
  let r = Buffer.create 17 in
  for i=0 to String.length s - 1 do
    let c = String.get s i in
    let d =
      match c with
      | '(' -> inpar := true ; ""
      | ')' -> inpar := false ; ""
      | '*' -> "STAR"
      | '=' -> "EQ"
      | '<' -> "LT"
      | '>' -> "GT"
      | '^' -> "CARET"
      | '|' -> "BAR"
      | '-' -> if !inpar then "MINUS" else "-"
      | '!' -> "BANG"
      | '.' -> if !inpar then "DOT" else "."
      | '$' -> "DOLLAR"
      | '&' -> "AMP"
      | '@' -> "AT"
      | '+' -> "PLUS"
      | '%' -> "PERCENT"
      | '\\' -> "BACKSL"
      | _ -> String.make 1 c
    in
    Buffer.add_string r d;
  done;
  Buffer.contents r

let rename f =
  let n =
    try
      let i = String.index f ':' in
      String.sub f 0 i
    with
	Not_found -> f
  in
  let l = String.length n in
  if l >= 3 && String.sub n (l-3) 3 = ".hs" then ()
  else
    let n =
      if l >= 11 && String.sub n 0 11 = "Prelude.hs_" then
	String.sub n 11 (l - 11)
      else n
    in
    do_rename f (tr n) 1

let () =
  Array.iter rename (Sys.readdir ".")
